﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Data;
using System.Collections.ObjectModel;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            Map1.CurrentExtent = new RectangleShape(-97.766, 30.291, -97.755, 30.286);
            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 233, 232, 214));
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ShapeFileFeatureLayer austinStreetsLayer = new ShapeFileFeatureLayer(Server.MapPath(@"~\app_data\austinstreets.shp"));
            austinStreetsLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.LocalRoad1;
            austinStreetsLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            austinStreetsLayer.DrawingMarginPercentage = 10;

            InMemoryFeatureLayer shapeLayer = new InMemoryFeatureLayer();
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.LocalRoad1;
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle.InnerPen.Color = GeoColor.FromArgb(20, 60, 180, 60);
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle.OuterPen.Color = GeoColor.GeographicColors.DeepOcean;
            shapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            Map1.StaticOverlay.Layers.Add("AustinStreets", austinStreetsLayer);
            Map1.DynamicOverlay.Layers.Add("Highlight", shapeLayer);
        }
    }

    protected void Button1Click(object sender, EventArgs args)
    {
        ShapeFileFeatureLayer austinStreetsLayer = (ShapeFileFeatureLayer)Map1.StaticOverlay.Layers["AustinStreets"];
        InMemoryFeatureLayer shapeLayer = (InMemoryFeatureLayer)Map1.DynamicOverlay.Layers["Highlight"];

        shapeLayer.InternalFeatures.Clear();

        austinStreetsLayer.Open();
        DataTable dataSource = austinStreetsLayer.QueryTools.ExecuteQuery(String.Format("SELECT RECID FROM austinstreets where FENAME='{0}' ORDER BY RECID", TextBox1.Text.Trim()));

        Collection<string> recIds = new Collection<string>();
        if(dataSource.Rows.Count > 0)
        {
            foreach (DataRow row in dataSource.Rows)
            {
                recIds.Add(row[0].ToString());
            }
        }

        Collection<Feature> features = austinStreetsLayer.QueryTools.GetFeaturesByIds(recIds, ReturningColumnsType.NoColumns);
        austinStreetsLayer.Close();

        foreach (Feature feature in features)
        {
            shapeLayer.InternalFeatures.Add(feature);
        }

        Map1.CurrentExtent = ExtentHelper.GetBoundingBoxOfItems(features);
    }
}
